#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <check.h>

#include "test_dff.h"


int bin2dec(char *bin)
{
        int  b, k, m, n;
        int  len, sum = 0;

        len = strlen(bin) - 1;
        for(k = 0; k <= len; k++)
        {
                n = (bin[k] - '0'); // char to numeric value
                if ((n > 1) || (n < 0))
                {
                        printf("Incorrect binary value. All values must be 0 or 1.\n");
                        return -1;
                }

                for(b = 1, m = len; m > k; m--)
                {
                        b *= 2;
                }

                sum = sum + n * b;
        }
        return sum;
}


int read_fpga(int device_handle, char* buffer)
{
        return pread(device_handle, buffer, 4, 0);
}


int write_fpga(int device_handle, char* buffer0, char* buffer1)
{
        char wbuffer[2];
        wbuffer[0] = bin2dec(buffer0);
        wbuffer[1] = bin2dec(buffer1);
        return pwrite(device_handle, wbuffer, 2, 0);
}


int write_fpga_zeros(int device_handle)
{
        return write_fpga(device_handle, "00000000", "00000000");
}

