#ifndef DFF_TEST_H
#define DFF_TEST_H

#define TEST_LOG_ONEDFF "/var/test_onedff.log"
#define TEST_LOG_THREEDFFS "/var/test_threedffs.log"

#define SWREG_DEVICE "/var/swreg"

//! Transform a char string of 0's and 1's to an integer.
int bin2dec(char *bin);

//! Write to the first and second HWSW-register. Each register is 8 bits long.
int write_fpga(int device_handle, char* buffer0, char* buffer1);
//! Write zeros to the first and second HWSW-register. Each register is 8 bits long.
int write_fpga_zeros(int device_handle);
//! Read all the 4 HWSW-registers (2 input and 2 output registers). Each register is 8 bits long.
int read_fpga(int device_handle, char* buffer);

//! Test the results from the HWSW-registers when the FPGA-design with only one flip-flop is on the FPGA.
int test_onedff(void);

//! Test the results from the HWSW-registers when the FPGA-design with three flip-flops is on the FPGA.
int test_threedffs(void);


#endif

