/*! \file hwos.h
 *  \brief [Hardware OS Interface] Top level daemon for HWOS.
 *
 *  This daemon communicates with a number of hardware modules through device drivers.
 *  The main goal of this software is to schedule run time on the FPGA for different modules.
 *  Another goal is to allocate/deallocate memory for the module.
 *
 *  Original author (2010): Vegard Endresen
 *
 *  Modified (2011) by: Sindre Hansen
 *      - Rewrote daemon.
 *      - Rewrote message interface and HWOS-library.
 *      - Added scheduler.
 *      - Added placer.
 *      - Added threads for message server and scheduler.
 */


#include "hstructures.h"

#ifndef HDAEMON_H
#define HDAEMON_H

#include "../platform_defines.h"
#if SUZAKU_BUILD
        #define DAEMON_LOG "/var/hwos_daemon.log"
#else
        #define DAEMON_LOG "../logs/hwos_daemon.log"
#endif

//! Device file root folder on Suzaku.
#define DEVICE_ROOT "/var/tmp/dev"

#endif

