/*! \file hwos.h
 *  \brief [Hardware OS Message Server] Top level daemon for HWOS message server.
 *
 *  Author (2011): Sindre Hansen
 */


#ifndef HDMSG_H
#define HDMSG_H

enum hdmevent {
       HDME_QUIT                         //! Quit the message server thread.
};

/*! \brief Main function for message server thread.
 */
void* hdmsg_main();
int hdmsg_notify(enum hdmevent event);

/*! \brief Send a dummy/sync message to the message server.
 *
 * @return 0 on success. Negative on failure.
 */
int hdmsg_synchronize();

#endif

