/*! \file hdplacer.h
 *  \brief [Hardware OS Placer] Top level module for placement on FPGA.
 *
 *  The responsibilities of this module is as follows:
 *
 *  - The module also takes care of periodically interrupting the process running on the FPGA and
 *  saving it's state. It also writes the state back to a process running on the FPGA if it is
 *  to be resumed.
 *
 *  - This module takes care of placement (of a process chosen by the scheduler) on the FGPA.
 *  In this version of the HWOS, the module always places the reconfigurable module at
 *  the same place using ICAP.
 *
 *  Original author (2010): Sindre Hansen
 *
 */

#ifndef HDPLACER_H
#define HDPLACER_H


enum hdpevent {
       HDPE_QUIT                         //! Quit the placer thread.
       ,HDPE_TIMER                       //! The timeslice has expired.
};

void* hdplacer_main();
int hdplacer_notify(enum hdpevent event);

#endif

