/*! \file hdtimer.h
 *  \brief [Hardware OS Timer] Timer for the HWOS Placer.
 *
 *  This module simply generates a timer interrupt to the placer module
 *  at the interval specified by hdtimer_get_timeslice().
 *
 *  Original author (2010): Sindre Hansen
 *
 */


#ifndef HDTIMER_H
#define HDTIMER_H

enum hdtevent {
       HDTE_QUIT                         //! Quit the timer thread.
};


int hdtimer_notify(enum hdtevent event);
const int hdtimer_get_timeslice();
void* hdtimer_main();

#endif

