#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hprocess.h"
#include "hplacer.h"
#include "hicap.h"

static char* bitfilespath = NULL;
static char* icap_device = NULL;

static const char* get_bitfilespath_();
static const char* get_icap_device_();



static const char* get_icap_device_()
{
        return icap_device;
}


static const char* get_bitfilespath_()
{
        return bitfilespath;
}


int hplacer_set_icapdevice(const char* device)
{
       icap_device = realloc(icap_device, strlen(device) + 1);
       strcpy(icap_device, device);
       return 0;
}


int hplacer_set_bitfilespath(const char* path)
{
       bitfilespath = realloc(bitfilespath, strlen(path) + 1);
       strcpy(bitfilespath, path);
       return 0;
}


char* hplacer_create_full_bitfilename(struct hprocess* process)
{
        if (process == NULL)
                return NULL;

        // Enough memory for the strings + null-char + '/'.
        char* full_filename = calloc(1, strlen(get_bitfilespath_()) + strlen(hprocess_get_bitfilename(process)) + 2);
        strcpy(full_filename, get_bitfilespath_());
        strcat(full_filename, "/");
        strcat(full_filename, hprocess_get_bitfilename(process));
        
        return full_filename;
}


int hplacer_interrupt_process(struct hprocess* process)
{
        return 0;
}


int hplacer_load_process(struct hprocess* process)
{
        char* filename_full = hplacer_create_full_bitfilename(process);
        int device_handle = hicap_open((char*)get_icap_device_(), "XC4VFX12");
        if (device_handle < 0)
                return -1;
        
        hicap_close(device_handle);
        free(filename_full);
        return 0;
}


