/*! \file hsignal.h
 *  \brief [Hardware OS Signal Interface] Defines possible signals that can be connected between modules.
 *
 *  Author (2011): Sindre Hansen
 *
 */

#ifndef HSIGNAL_H
#define HSIGNAL_H

enum hsignal {
        //! hsqlist to hsqueue. A queue has been added to a list.
        HSIGNAL_ADD_QUEUE,
        //! hsqlist to hsqueue. A queue has been removed from a list.
        HSIGNAL_REMOVE_QUEUE,
        //! hsqueue to hprocess. A process has been added to a queue.
        HSIGNAL_ADD_PROCESS,
        //! hsqueue to hprocess. A process has been removed from a queue.
        HSIGNAL_REMOVE_PROCESS
};

#endif

