/*! \file hstructures.h
 *  \brief [Hardware OS public structures] Public structures used in the HWOS.
 *
 *  Author (2011): Sindre Hansen
 *
 */

#ifndef HSTRUCTURES_H
#define HSTRUCTURES_H

//! A process in the HWOS. Can be running on the FPGA.
struct hprocess;

//! A message queue in the HWOS. Used by the message server.
struct hmqueue;

//! A queue of processes in the HWOS.
struct hsqueue;

//! A device driver for a backend on the FPGA.
struct hdev;

//! A generic list structure for use in the HWOS.
struct hlist;

//! A generic list element for use in the generic list structure.
struct hlelement;

//! A generic list element that does not belong to any list element.
//! It has a next and a previous field.
struct hlorphan;

//! A pointer to a block of BRAM-memory on the FPGA.
struct hvmemptr;

//! An event for use in the event system between threads in the HWOS.
struct hevent;

#endif


