#include <stdio.h>
#include <stdlib.h>

#include "hvmemptr.h"

struct hvmemptr {
        struct hlelement* bramentry;              //! Points to the list element pointing to the first physical BRAM entry.
        int size;                                 //! Number of virtual memory entries in this hvmemptr's memory block.
};


struct hvmemptr* hvmemptr_create(struct hlelement* entry, int size)
{
        struct hvmemptr* pointer = calloc(1, sizeof(struct hvmemptr));
        pointer->bramentry = entry;
        pointer->size = size;

        return pointer;
}


struct hlelement* hvmemptr_get_bramentry(struct hvmemptr* pointer)
{
        if (pointer == NULL)
                return NULL;
        
        return pointer->bramentry;
}


int hvmemptr_set(struct hvmemptr* pointer, struct hlelement* entry, int size)
{
        if (pointer == NULL)
                return -1;
        
        pointer->bramentry = entry;
        pointer->size = size;

        return 0;
}

int hvmemptr_get_size(struct hvmemptr* pointer)
{
        if (pointer == NULL)
                return -1;

        return pointer->size;
}


