#include <stdio.h>

#include <hlog.h>
#include <hicap.h>
#include "test_hwos.h"

int main()
{
        hlog_init(DAEMON_CLIENT_LOG);

        int do_fpga_test = 0;
        int do_daemon_test = 1;
        
        printf("1=yes, 0=no\n");
        printf("Perform test on daemon (daemon must be started)?\n");
        scanf("%d", &do_daemon_test);

        int number_failed = 0;

        printf("===\n");
        number_failed += test_hprocess();
        printf("===\n");
        number_failed += test_hsqueue();
        printf("===\n");
        number_failed += test_hsqlist();
        printf("===\n");
        number_failed += test_hmqueue();
        printf("===\n");
        number_failed += test_hdev();
        printf("===\n");
        number_failed += test_hlist();
        printf("===\n");
        number_failed += test_hvmem();
        if (do_daemon_test) {
                printf("===\n");
                number_failed += test_hwos_daemon();
        }

        if (do_fpga_test) {
                printf("===\n");
                //number_failed += test_hplacer();
                number_failed += test_hicap();
        }

        printf("\nSummary:\n");
        if (number_failed == 0)
                printf("All tests passed!\n");
        else
                printf("Test suites that failed: %d\n.", number_failed);

        hlog_close();
        return 0;
}


