/* Note: The hvmem-functionality is NOT done.
 * These tests can be used for further development.
 *
 */



#include <stdlib.h>
#include <check.h>
#include <string.h>

#include <hvmem.h>
#include <hprocess.h>
#include "test_hwos.h"


static void setup (void);
static void teardown (void);
static Suite* hvmem_suite (void);


static struct hprocess* process0;
static struct hprocess* process1;

static void setup (void)
{
        process0 = hprocess_create(11);
        process1 = hprocess_create(1);
}

static void teardown (void)
{
        hprocess_remove(process0);
        hprocess_remove(process1);
}


START_TEST (test_hvmem_allocate)
{
        // TODO: Should be separated into several cases (many different cases are tested here).
        // TODO: The process argument is wrong each time! Must change it and test it!
        struct hvmemptr* ptr0 = hvmem_allocate(process0, 3);
        fail_unless (ptr0 != NULL, "Virtual pointer is null");
        fail_unless (hvmem_get_free_count() == 7, "Wrong free count. It is: %d", hvmem_get_free_count());
        struct hvmemptr* ptr1 = hvmem_allocate(process1, 6);
        fail_unless (ptr1 != NULL, "Virtual pointer is null");
        fail_unless (hvmem_get_free_count() == 1, "Wrong free count.");
        struct hvmemptr* ptr2 = hvmem_allocate(process1, 1);
        fail_unless (ptr2 != NULL, "Virtual pointer is null");
        fail_unless (hvmem_get_free_count() == 0, "Wrong free count. It is: %d", hvmem_get_free_count());
        fail_unless(hvmem_free(process0, ptr0) == 3, "Wrong number of bytes freed.");
        fail_unless (hvmem_get_free_count() == 3, "Wrong free count. It is: %d", hvmem_get_free_count());
        struct hvmemptr* ptr3 = hvmem_allocate(process1, 3);
        fail_unless (ptr3 != NULL, "Virtual pointer is null");
        fail_unless (hvmem_get_free_count() == 0, "Wrong free count. It is: %d", hvmem_get_free_count());
        fail_unless(hvmem_free(process0, ptr1) == 6, "Wrong number of bytes freed.");
        //printf("---\n");
        //hvmem_print_entries();
        struct hvmemptr* ptr4 = hvmem_allocate(process1, 3);
        //printf("---\n");
        //hvmem_print_entries();
        struct hvmemptr* ptr5 = hvmem_allocate(process1, 1);
        //printf("---\n");
        //hvmem_print_entries();
}
END_TEST


static Suite* hvmem_suite (void)
{
        Suite *s = suite_create ("hvmem");

        /* Core test case */
        TCase *tc_core = tcase_create ("Core");
        tcase_add_checked_fixture (tc_core, setup, teardown);
        tcase_add_test (tc_core, test_hvmem_allocate);
        suite_add_tcase (s, tc_core);

        return s;
}

int test_hvmem (void)
{
        int number_failed;
        Suite *s = hvmem_suite ();
        SRunner *sr = srunner_create (s);
        srunner_set_log (sr, TEST_LOG_HVMEM);
        srunner_run_all (sr, CK_VERBOSE);

        number_failed = srunner_ntests_failed (sr);
        srunner_free (sr);
        return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
}

