-------------------------------------------------------------------------------
--
-- Title       : combined_shift
-- Design      : parallel_blocks
-- Author      : Vegard
-- Company     : NTNU
-- Description : 
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity combined_shift is
	generic(C_SIZE : natural :=8);
	port(	   
		clk		: in  std_logic;
		data_i  : in  std_logic_vector(C_SIZE-1 downto 0);
		shift	: in  std_logic;
		write	: in  std_logic;
		data_o	: out std_logic_vector(C_SIZE-1 downto 0)
	);
end combined_shift;


architecture combined_shift of combined_shift is
signal memory : std_logic_vector(C_SIZE-1 downto 0);
begin
	
	data_o <= memory;
	
	write_proc : process(clk) is 
	begin  
		if clk'event and clk ='1' then
			if write = '1' then 
				memory <= data_i;
			elsif shift ='1' then
				memory(C_SIZE-1) <= data_i(0);
				for i in C_SIZE-2 downto 0 loop
					memory(i) <= memory(i+1);		
				end loop;
			end if;
		end if;
		
	end process write_proc;
	
	

end combined_shift;
