-------------------------------------------------------------------------------
--
-- Title               : multiplier
-- Design              : reconfiguration
-- Orginal author      : Vegard Endresen
-- Author              : Sindre Hansen
-- Company             : NTNU
-- Description         : Dummy module to make Vegard Endresen's backend
--                       reconfigurable.
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.std_logic_unsigned.all;


entity multiplier is
generic(
		OPERAND_SIZE      	: natural	:=32;
		SHIFT_SIZE			: natural   :=8;
		LOG_OPERAND_SIZE	: natural   :=5
		);

	port(
		clk			: in 	std_logic;
		reset		: in    std_logic;
		run			: in 	std_logic; 
		addr		: in    std_logic;
		zerofill	: in    std_logic;
		shift_i 	: in 	std_logic_vector(SHIFT_SIZE-1 downto 0);
		shift_g		: in 	std_logic;
		shift_o 	: out 	std_logic_vector(SHIFT_SIZE-1 downto 0);
		finish		: out	std_logic 
	);

end multiplier;


architecture arch of multiplier is
begin
	
	-- Just connect the signals somewhere (doesn't matter and makes error messages go away).
	--shift_o <= shift_i;
	
	
	-- Just a simple DFF to make sure the clock
	-- has been routed into the dummy module.
	OUT_PROC : process(clk, reset)
	begin
		if (reset='1') then
			finish <= '0';
		elsif (clk'EVENT and clk='1') then
			finish <= run;
		end if;
	end process OUT_PROC;
	

end arch;
