-------------------------------------------------------------------------------
--
-- Title       : paralell_shift
-- Design      : parallel_blocks
-- Author      : Vegard
-- Company     : NTNU
-- Description : Paralell shift unit 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity paralell_shift is
	generic(C_SIZE : natural :=8);
	port(	   
		clk		: in  std_logic;
		data_i : in  std_logic_vector(C_SIZE-1 downto 0);
		write	: in  std_logic;
		data_o	: out std_logic_vector(C_SIZE-1 downto 0)
	);

end paralell_shift;


architecture paralell_shift of paralell_shift is

signal memory : std_logic_vector(C_SIZE-1 downto 0);
begin
	
	data_o <= memory;
	
	write_proc : process(clk) is 
	begin  
		if clk'event and clk ='1' then
			if write = '1' then 
				memory <= data_i;
			end if;
		end if;
		
	end process write_proc;
	
	
	
end paralell_shift;
