-------------------------------------------------------------------------------
--
-- Title       : multiplex_custom
-- Design      : sequential_multiplier
-- Author      : Vegard
-- Company     : NTNU
-- Description : Multiplexer for addressing in reconfigurable module.
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
entity mux_custom is
	port(
 		input			: in  std_logic_vector(15 downto 0);
	 	addr			: in  std_logic;
	 	output			: out std_logic_vector(7 downto 0)
);end mux_custom;

architecture RTL of mux_custom is
begin
DECODE_PROC : process(addr,input) is 
begin
	case addr is
		when '0' =>
			output <= input(7 downto 0);
		when '1' =>
			output <= input(15 downto 8); 
		when others =>
			output <= input(7 downto 0);
	end case;
end process DECODE_PROC;

end architecture RTL;
